
<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="renderer" content="webkit">
    <meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
    <title>【原创】自制编程语言-5 变量的赋值（1） / 开普饭 </title>
    <meta name="description" content="【原创】自制编程语言-5 变量的赋值（1） 首先我们先看这个函数: void put_value(const char *name){ for(int i=0;i&lt;value_ptr;i++){ if(strcmp(value[i].name,s)==0){ if(value[i].type==0)printf(&quot;%d&quot;,value[i].vnum); else printf(&quot;%s&quot;,value[i].vstring); } } } 这个函数写得不是很好,因为首先根据变量名找变量的功能可能会 ..." />
    <meta name="applicable-device" content="pc,mobile" />
          
    <link rel='dns-prefetch' href='//pic.ikafan.com' />
    <link rel='stylesheet' id='stylesheet-css' href='//n4.ikafan.com/assetsj/style.css' type='text/css' media='all' />
    <!-- <link rel='stylesheet' id='stylesheet-css'  href='https://computeinit.com/wp-content/themes/justnews/css/style.css?ver=6.9.2' type='text/css' media='all' /> -->
      
    <script src="https://n4.ikafan.com/g/show.js"></script>
        <!--[if lte IE 9]><script src="//n4.ikafan.com/assetsj/update.js"></script><![endif]-->
</head>
<body class="archive qapress-list el-boxed">

<header class="header">
    <div class="container clearfix">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".navbar-collapse" aria-label="menu">
                <span class="icon-bar icon-bar-1"></span>
                <span class="icon-bar icon-bar-2"></span>
                <span class="icon-bar icon-bar-3"></span>
            </button>
                        <div class="logo">
                <a href="/" rel="home"><img src="//n4.ikafan.com/assetsj/logo.png" alt="开普饭"></a>
            </div>
        </div>
        <div class="collapse navbar-collapse">
            <nav class="navbar-left primary-menu">
                <ul id="menu-justnews-menu" class="nav navbar-nav wpcom-adv-menu">
                                        <li class="menu-item"><a href="/about/hot/">热门推荐</a></li>
                                        <li class="menu-item"><a href="/about/new/">最新更新</a></li>
                                        <li class="menu-item"><a href="/about/editor/">编辑推荐</a></li>
                                   
                </ul>
            </nav>            
            <!-- <div class="navbar-action pull-right">
                <div class="navbar-search-icon j-navbar-search"><i class="wpcom-icon wi"><svg aria-hidden="true"><use xlink:href="#wi-search"></use></svg></i></div>
                <div id="j-user-wrap"> 
                </div>
                <a class="btn btn-primary btn-xs" href="#">
                    xxx</a>
            </div>
            <form class="navbar-search" action="/search/" method="get" role="search">
                <div class="navbar-search-inner">
                    <i class="wpcom-icon wi navbar-search-close"><svg aria-hidden="true"><use xlink:href="#wi-close"></use></svg></i>                    <input type="text" name="s" class="navbar-search-input" autocomplete="off" placeholder="输入关键词搜索..." value="">
                    <button class="navbar-search-btn" type="submit"><i class="wpcom-icon wi"><svg aria-hidden="true"><use xlink:href="#wi-search"></use></svg></i></button>
                </div>
            </form> -->
        </div><!-- /.navbar-collapse -->
    </div><!-- /.container -->
</header><div id="wrap">    
    <div class="wrap container">
        <main class="main">
            <article class="entry">
                <div class="entry-main">
                    <div class="entry-head">
                        <h1 class="entry-title">【原创】自制编程语言-5 变量的赋值（1）</h1>
                        <div class="entry-info">
                            <time class="entry-date published"  pubdate>2024-01-30 08:23:30</time>  
                        </div>                    </div>
                    <div id="single_top"></div>
<script>insertAdIfNeeded();</script>                        <!-- <div class="entry-excerpt entry-summary">
                            
                        </div> -->
                    <div class="entry-content">
                        <p>首先我们先看这个函数：</p>
<blockquote><p>void put_value(const char *name){</p>
<p>for(int i=0;i&lt;value_ptr;i++){</p>
<p>if(strcmp(value[i].name,s)==0){</p>
<p>if(value[i].type==0)printf("%d",value[i].vnum);</p>
<p>else printf("%s",value[i].vstring);</p>
<p>}</p>
<p>}</p>
<p>}</p></blockquote>
<p>这个函数写得不是很好，因为首先根据变量名找变量的功能可能会在很多情况下使用到，每次都写一个for循环很麻烦，所以，我们可以单独把这个功能提取出来，写成一个函数的形式。</p>
<p>至于函数名，就叫getpos吧。pos是position的缩写。</p>
<blockquote><p>int getpos(const char *vname){</p>
<p>for(int i=0;i&lt;value_ptr;i++){</p>
<p>if(strcmp(value[i].name,vname)==0)return i;//下标</p>
<p>}</p>
<p>return -1;//未找到</p>
<p>}</p></blockquote>
<p>根据变量名，反复的循环比较变量名，直到找到正确的数字，返回这个下标。如果没有，返回-1。</p>
<p>根据这段代码，我们就可以简化put_value。</p>
<blockquote><p>void put_value(const char *name){</p>
<p>int i=getpos(name);</p>
<p>if(i==-1)error();</p>
<p>if(value[i].type==0)printf("%d",value[i].vnum);</p>
<p>else printf("%s",value[i].vstring);</p>
<p>}</p></blockquote>
<p>我们来运行一下试试。结果应该还是正常的。接下来我们就进入正题，变量的赋值语句。一般的赋值语句应该都长成这样：</p>
<blockquote><p>变量名 = 表达式</p></blockquote>
<p>为了读入方便，这里规定：变量名和"="和后面的表达式中间必须加上空格，这样直接用scanf("%s")就可以读入了，不用人工分割单词。</p>
<blockquote><p>else if(isvalue(s)){//变量的赋值语句</p>
<p>char sa[255],sb[255];</p>
<p>get_word(sa);get_word(sb);</p>
<p>if(strcmp(sa,"=")!=0)error();</p>
<p>if(value[getpos(s)].type==0)value[getpos(s)].vnum=getnum(sb);</p>
<p>else {</p>
<p>sb[strlen(sb)-1]='\0';//去掉最后的双引号</p>
<p>strcpy(value[getpos(s)].vstring,sb+1);//复制的时候去掉前面的双引号</p>
<p>}</p>
<p>}</p></blockquote>
<p>首先读入sa和sb，s存放要赋值的变量，sa存放等号，sb存放后面的表达式。这里，分两种情况进行赋值。如果是数字，把表达式sb求出数字，放入value，如果是字符串，去掉前后引号放进去。</p>
<p>然后是getnum。这个函数需要实现表达式求值的功能。例如，</p>
<blockquote><p>a = 1+2*3+4</p></blockquote>
<p>这样的语句，必须根据运算优先级求出这样长的表达式。当然，我们一步一步来，先实现把一个字符串转换为常数的功能。</p>
<blockquote><p>int getnum(const char *s){</p>
<p>int i;</p>
<p>sscanf(s,"%d",&amp;i);</p>
<p>return i;</p>
<p>}</p></blockquote>
<p>实际上，把一个字符串转换为常数非常简单，使用sscanf往字符串读入常数即可。关于sscanf的用法，可以自行在网上搜索。</p>
<p>我们用如下的代码测试一个：</p>
<blockquote><p>dim a as int</p>
<p>dim str as string</p>
<p>a = 123</p>
<p>str = "hello"</p>
<p>print a</p>
<p>print str</p>
<p>exit</p></blockquote>
<p>运行非常成功，输出“123hello”。完。</p>
<p>顺便把完整版代码贴一下，一共109行。</p>
<p>#include&lt;bits/stdc++.h&gt;<br />
using namespace std;<br />
char s[100];<br />
struct VALUE{<br />
&nbsp; &nbsp; &nbsp; &nbsp; char name[30];//变量名<br />
&nbsp; &nbsp; &nbsp; &nbsp; int type;//类型，0表示int，1表示string<br />
&nbsp; &nbsp; &nbsp; &nbsp; int vnum;//int类型的数值<br />
&nbsp; &nbsp; &nbsp; &nbsp; char vstring[255];//string类型<br />
};<br />
int value_ptr=0;<br />
struct VALUE value[1000];<br />
void get_word(char *s){//读入单词<br />
&nbsp; &nbsp; &nbsp; &nbsp; scanf("%s",s);<br />
}<br />
void get_string(char *s){<br />
&nbsp; &nbsp; &nbsp; &nbsp; int i=0,flag=0;<br />
&nbsp; &nbsp; &nbsp; &nbsp; for(i=0;i&lt;100;i++){<br />
next:<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; s[i]=getchar();<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(flag==0 &amp;&amp; s[i]==' ')goto next;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else flag=1;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(s[i]=='\n')break;<br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; s[i]='\0';//结束掉字符串<br />
}<br />
void error(){<br />
&nbsp; &nbsp; &nbsp; &nbsp; cout&lt;&lt;"Error in program.\n";<br />
&nbsp; &nbsp; &nbsp; &nbsp; exit(0);//退出程序<br />
}<br />
int isnumber(const char *s){<br />
&nbsp; &nbsp; &nbsp; &nbsp; for(int i=0;i&lt;strlen(s);i++)<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(s[i]&lt;='0' || s[i]&gt;='9')return 0;//不是数字字符<br />
&nbsp; &nbsp; &nbsp; &nbsp; return 1;<br />
}<br />
int isvalue(const char *s){<br />
&nbsp; &nbsp; &nbsp; &nbsp; for(int i=0;i&lt;value_ptr;i++){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(strcmp(value[i].name,s)==0)return 1;<br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; return 0;<br />
}<br />
int getpos(const char *vname){<br />
&nbsp; &nbsp; &nbsp; &nbsp; for(int i=0;i&lt;value_ptr;i++){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(strcmp(value[i].name,vname)==0)return i;//下标<br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; return -1;//未找到<br />
}<br />
void put_value(const char *name){<br />
&nbsp; &nbsp; &nbsp; &nbsp; int i=getpos(name);<br />
&nbsp; &nbsp; &nbsp; &nbsp; if(i==-1)error();<br />
&nbsp; &nbsp; &nbsp; &nbsp; if(value[i].type==0)printf("%d",value[i].vnum);<br />
&nbsp; &nbsp; &nbsp; &nbsp; else printf("%s",value[i].vstring);<br />
}<br />
int getnum(const char *s){<br />
&nbsp; &nbsp; &nbsp; &nbsp; int i;<br />
&nbsp; &nbsp; &nbsp; &nbsp; sscanf(s,"%d",&amp;i);<br />
&nbsp; &nbsp; &nbsp; &nbsp; return i;<br />
}<br />
int main(int argc,char** argv){<br />
&nbsp; &nbsp; &nbsp; &nbsp; if(argc!=2){//有一个要解释的文件参数<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; cout&lt;&lt;"Cannot find source file.\n";<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; return 0;<br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; freopen(argv[1],"r",stdin);<br />
&nbsp; &nbsp; &nbsp; &nbsp; for(;;){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; get_word(s);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(strcmp(s,"print")==0){//调用print输出<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; get_string(s);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(isnumber(s))cout&lt;&lt;s;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else if(s[0]=='\"' &amp;&amp; s[strlen(s)-1]=='\"'){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; for(int i=1;i&lt;strlen(s)-1;i++){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(s[i]=='\\' &amp;&amp; s[i+1]=='n'){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; printf("\n");i++;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else printf("%c",s[i]);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else if(isvalue(s)){<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; put_value(s);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else error();<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else if(strcmp(s,"exit")==0){//退出程序<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; return 0;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else if(strcmp(s,"dim")==0){//声明变量<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; char sa[255],sb[255],sc[255];<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; get_word(sa);get_word(sb);get_word(sc);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(strcmp(sb,"as")!=0)error();<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; strcpy(value[value_ptr].name,sa);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(strcmp(sc,"int")==0)value[value_ptr].type=0;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else if(strcmp(sc,"string")==0)value[value_ptr].type=1;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else error();<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; value_ptr++;<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else if(isvalue(s)){//变量的赋值语句<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; char sa[255],sb[255];<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; get_word(sa);get_word(sb);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(strcmp(sa,"=")!=0)error();<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if(value[getpos(s)].type==0)value[getpos(s)].vnum=getnum(sb);<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else {<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; sb[strlen(sb)-1]='\0';//去掉最后的双引号<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; strcpy(value[getpos(s)].vstring,sb+1);//复制的时候去掉前面的双引号<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; else{<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; error();<br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br />
}</p>                        <div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>                                                  
                     </div>

                    <div class="entry-tag"></div>
                                            <div class="entry-action">
                            <div class="btn-zan" data-id="7544"><i class="wpcom-icon wi"><svg aria-hidden="true"><use xlink:href="#wi-thumb-up-fill"></use></svg></i> 赞 <span class="entry-action-num">(0)</span></div>
                        </div>
                    
                    
                </div>
                <!-- <div class="sec-panel main-list main-list-default">
                    <div class="tab-wrap active">
                        <ul class="post-loop post-loop-default cols-3">
                             
                        </ul>
                    </div>
                </div>  -->
                 
                <div class="entry-related-posts">
                    <h3 class="entry-related-title">相关推荐</h3>
                    <ul class="entry-related post-loop-default">
                     
 
                    </ul>
                </div>  
                                            </article>
        </main>

<aside class="sidebar">
    <div id="wpcom-lastest-news-3" class="widget widget_lastest_news"><h3 class="widget-title"><span>热门文章</span></h3>            
        <ul>
                                    <li><a href="https://www.kpfans.com/article/GK92zj6E9L.html" title="自然界中大部分动物是雄性比雌性漂亮，为啥人类女性比男性漂亮？">自然界中大部分动物是雄性比雌性漂亮，为啥人类女性比男性漂亮？</a></li>
                        <li><a href="https://www.kpfans.com/article/YG93jNDQvx.html" title="世界读书日5年500本书单：你有多久没阅读了？">世界读书日5年500本书单：你有多久没阅读了？</a></li>
                        <li><a href="https://www.kpfans.com/article/3RWV8YNmvN.html" title="缅甸大部分私立银行已恢复营业，贷款人面临催款压力">缅甸大部分私立银行已恢复营业，贷款人面临催款压力</a></li>
                        <li><a href="https://www.kpfans.com/article/Yo5J8lNQ94.html" title="问候亲友三月初四早上好！（大狮代办1032）">问候亲友三月初四早上好！（大狮代办1032）</a></li>
                        <li><a href="https://www.kpfans.com/article/XRvkggDrvB.html" title="麦肯锡：2021中国消费者报告：洞悉中国消费者，全球增长引擎">麦肯锡：2021中国消费者报告：洞悉中国消费者，全球增长引擎</a></li>
                        <li><a href="https://www.kpfans.com/article/ErvbwA3b9p.html" title="真正高情商的人，更懂得这样做人">真正高情商的人，更懂得这样做人</a></li>
                        <li><a href="https://www.kpfans.com/article/RvkqQ8oAWB.html" title="学校管文化、校外管生活是教育领域最好的&quot;高低搭配&quot;">学校管文化、校外管生活是教育领域最好的&quot;高低搭配&quot;</a></li>
                        <li><a href="https://www.kpfans.com/article/zWQbbJXR5o.html" title="读书札记 | 德鲁克《卓有成效的个人管理》之三">读书札记 | 德鲁克《卓有成效的个人管理》之三</a></li>
                        <li><a href="https://www.kpfans.com/article/o5JBkVrg54.html" title="无敌药酒特效处方">无敌药酒特效处方</a></li>
                        <li><a href="https://www.kpfans.com/article/VWMK3x6ov1.html" title="《乔家的儿女》中的美女，28岁嫁给导演，如今32岁演叶小朗被骂惨">《乔家的儿女》中的美女，28岁嫁给导演，如今32岁演叶小朗被骂惨</a></li>
                    </ul>
    </div>

    <div id="wpcom-post-thumb-6" class="widget widget_post_thumb"><h3 class="widget-title"><span>随机推荐</span></h3>            
        <ul>
                                       
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/pO9Pp7Yg9a.html" title="省法院出台营商环境问题投诉联动工作办法">省法院出台营商环境问题投诉联动工作办法</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/7OWgn6dq9J.html" title="10种男人补气血的中药（下）">10种男人补气血的中药（下）</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/ZzW44rG4WV.html" title="《细胞》重磅：自动激活燃脂的开关找到了！科学家发现自动激活棕色脂肪细胞燃脂的受体，将其过表达还能把白...">《细胞》重磅：自动激活燃脂的开关找到了！科学家发现自动激活棕色脂肪细胞燃脂的受体，将其过表达还能把白...</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/JzWQYYNLWo.html" title="学英语必须知道的18个免费英文词典">学英语必须知道的18个免费英文词典</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/MZv06ZDmWk.html" title="菜鸟菜菜飞——我认识的最背运的人走了">菜鸟菜菜飞——我认识的最背运的人走了</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/PxWDj78xvn.html" title="高温来袭，如何应对“空调病”？">高温来袭，如何应对“空调病”？</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/1BWxgV8G92.html" title="篮网直接把冠军买了！6人41次入选全明星！篮网直接叫板19年宇宙勇！">篮网直接把冠军买了！6人41次入选全明星！篮网直接叫板19年宇宙勇！</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/EK9Xw3mKvw.html" title="11省份高考分数线公布！速查">11省份高考分数线公布！速查</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/yXWyqYMKW1.html" title="承袭古法，创新风格，独具魅力，书坛楷书此人若居第二则无第一">承袭古法，创新风格，独具魅力，书坛楷书此人若居第二则无第一</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/pO9PmnAkWa.html" title="【贵州】何开雄丨诗歌/雨的秘密">【贵州】何开雄丨诗歌/雨的秘密</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/aR5lP0Ba5M.html" title="看不懂笔法？我画给你看">看不懂笔法？我画给你看</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/GB97wrXp9E.html" title="前列癃闭通">前列癃闭通</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/aR5loNGZWM.html" title="中国七大传世手工艺之美，惊艳了世界!|景泰蓝|珐琅|玉雕|工艺品|玉器|青铜器">中国七大传世手工艺之美，惊艳了世界!|景泰蓝|珐琅|玉雕|工艺品|玉器|青铜器</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/XRvky71QWB.html" title="中巨奖后的十大人生结局 喜忧参半全凭一念之间">中巨奖后的十大人生结局 喜忧参半全凭一念之间</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/EK9XOV8Xvw.html" title="秦皮（漏下、&#160;交接出血）-- 马氏妇科">秦皮（漏下、&#160;交接出血）-- 马氏妇科</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/1VWGQoVQvP.html" title="叹亡真言【十一】">叹亡真言【十一】</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/ZzW4pGe6WV.html" title="|必读|年复一年，有些新冠病毒已经让您“闻风丧胆”">|必读|年复一年，有些新冠病毒已经让您“闻风丧胆”</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/bzvmq3Prv6.html" title="【艺展中国】邝声｜朴厚求新的老艺术家">【艺展中国】邝声｜朴厚求新的老艺术家</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/wLWoVVPY9j.html" title="【总第1236期】【辽宁&#183;阜新】王显新丨七一抒怀">【总第1236期】【辽宁&#183;阜新】王显新丨七一抒怀</a></p>
                                    </div>
            </li>
                           
            <li class="item">
                            <div class="item-content item-no-thumb">
                    <p class="item-title"><a href="https://www.kpfans.com/article/wrWz1GZz9x.html" title="为什么说喝了普洱茶后，会出汗，不一定是好茶？">为什么说喝了普洱茶后，会出汗，不一定是好茶？</a></p>
                                    </div>
            </li>
                    </ul>
    </div>
        <div id="wpcom-lastest-news-3" class="widget widget_lastest_news"><h3 class="widget-title"><span>热门标签</span></h3>            
        <ul>
                                    
        </ul>
    </div> 
               
</aside>

            </div>
</div>
<footer class="footer width-footer-bar">
    <div class="container">
        <div class="clearfix">
            <div class="footer-col footer-col-logo">
                <img src="//n4.ikafan.com/assetsj/logo.png" alt="开普饭">
            </div>
            <div class="footer-col footer-col-copy">
                  
                <div class="copyright">
                    <p>&#169; <span id="currentFullYear">2024</span>  <a href="/">开普饭</a></p>
                </div>
            </div>
            <div class="footer-col footer-col-sns">

            </div>
        </div>
    </div>
</footer>
    
    
    <script type='text/javascript' src='//n4.ikafan.com/assetsj/icons-2.6.18.js'></script>                            
    <script type='text/javascript' src='//n4.ikafan.com/assetsj/jquery-3.6.0.min.js'></script>
    <!-- <script type='text/javascript' src='https://computeinit.com/wp-includes/js/jquery/jquery-migrate.min.js'></script>                     -->
    <script type='text/javascript'>
    /* <![CDATA[ */
    var _wpcom_js = {};
    /* ]]> */
    </script>
    <script type='text/javascript' src='//n4.ikafan.com/assetsj/main.js'></script>

    <script>
    var _hmt = _hmt || [];
    (function() {
      var hm = document.createElement("script");
      hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
      var s = document.getElementsByTagName("script")[0]; 
      s.parentNode.insertBefore(hm, s);
    })();
    </script> 
 
</body>
</html>